/*
****************************************************************************************************
*                                                DUCP
*                      				Displayer universal control protocal
*                                      	   Master Head File
*
*                          			(c) Copyright 2016-2017, KF 
*                                        All Rights Reserved
*
* File : DUCP.h
* By   : Lyon 
* Date : 2016-1-1
* Email: yangzhonglai@163.com
****************************************************************************************************
*/
#ifndef _DUCP_H_
#define _DUCP_H_

#define DUCP_PATH_LEN_MAX		(125)


#define DUCP_FM_READ			(0X01)
#define DUCP_FM_WRITE			(0X02)
#define DUCP_FM_OPEN_ALWAYS		(0X10)
#define DUCP_FM_FLLOW_PATH		(0X80)


#define SEND_MSG_OVERTIME_DEF		(100)
#define READ_MSG_OVERTIME_DEF		(100)


#define DUCP_TTS_PLAY_OPT_A			(0x00)	/*ӵеǲʼ*/
#define DUCP_TTS_PLAY_OPT_AS		(0x01)	/*ӵвҿʼ*/
#define DUCP_TTS_PLAY_OPT_CAS		(0x02)	/*УУȻʼ*/

/**/
#define DUCP_ERR_NONE				(0x00) /*޴*/
typedef uint8_t DUCP_ERR_T;

/*-------------------------UDCPָ----------------------------*/
#define DUCP_CMD_SYS_BASE		(0)
#define DUCP_CMD_FM_BASE		(0X20)
#define DUCP_CMD_TTS_BASE		(0X30)
#define DUCP_CMD_2D_BASE		(0X38)
#define DUCP_CMD_WM_BASE		(0X50)
#define DUCP_CMD_TWIN_BASE		(0X60)
#define DUCP_CMD_PIC_BASE		(0X80)

typedef enum {
			/*--------------------ϵͳ------------------------------*/
			DUCP_CMD_SYS_CONNECT = DUCP_CMD_SYS_BASE, /*0¼UDCP OK*/		
			DUCP_CMD_SYS_SYN_PN,			/*1ͬ OK*/		
			DUCP_CMD_SYS_SET_PASSWAORD,		/*2޸ĵ¼ NOTEST*/
			DUCP_CMD_SYS_GET_PASSWAORD,		/*3ȡ¼ NOTEST*/
			DUCP_CMD_SYS_GET_FIRMWARE,		/*4ȡ̼ϢOK*/
			DUCP_CMD_SYS_UPTIME,			/*5ʱOK*/
			DUCP_CMD_SYS_RESET,				/*6ϵͳ OK*/

			DUCP_CMD_SYS_SET_ADDR,			/*7485ַ OK*/
			DUCP_CMD_SYS_SET_IP,			/*8IPַ OK*/
			DUCP_CMD_SYS_SET_PORT,			/*9ö˿ OK*/
			DUCP_CMD_SYS_SET_BAUD,			/*10òOK*/
			DUCP_CMD_SYS_SET_SCAN_FRE,		/*11ɨƵOK*/
			DUCP_CMD_SYS_SET_LIGHT,	 		/*12OK*/
			DUCP_CMD_SYS_SET_VOL,		 	/*13OK*/
			
			DUCP_CMD_SYS_CFG_IO,			/*14IOڹOK*/
			DUCP_CMD_SYS_SET_IO,			/*15IO״̬OK*/
			DUCP_CMD_SYS_READ_IO,			/*16ȡIO״̬OK*/

			DUCP_CMD_SYS_SET_DRV,			/*17LEDOK*/
			DUCP_CMD_SYS_SET_OEP,			/*18OEOK*/
			DUCP_CMD_SYS_SET_DP,			/*19ݼOK*/
			DUCP_CMD_SYS_SET_LE,			/*20LEźʱOK*/
			DUCP_CMD_SYS_SET_GW_AND_MASK,	/*21غOK*/
			DUCP_CMD_SYS_SET_SAF_MODE,		/*22밲ȫģʽOK*/
			DUCP_CMD_SYS_CLIC,				/*23Passport OK*/
			DUCP_CMD_SYS_SET_DIS_SIZE,		/*24ʾߴOK*/
			DUCP_CMD_SYS_SET_XYMIR,			/*25ʾOK*/
			DUCP_CMD_SYS_SET_485MODE,		/*26485ģʽOK*/
			DUCP_CMD_SYS_GET_ALL,			/*27ȡвOK*/
			DUCP_CMD_SYS_SET_ALL,			/*28вOK*/
			DUCP_CMD_SYS_SET_TTSEN,			/*29ʹܲıOK*/
			
			/*--------------------ļ------------------------------*/
			DUCP_CMD_FM_MOUNT = DUCP_CMD_FM_BASE,/*Ŀ¼ INVOLID*/
			DUCP_CMD_FM_OPEN,				/*򿪻򴴽ļ INVOLID*/
			DUCP_CMD_FM_SEEK,				/*ļдλ INVOLID*/
			DUCP_CMD_FM_WRITE,				/*дļ INVOLID*/
			DUCP_CMD_FM_READ,				/*ļ INVOLID*/
			DUCP_CMD_FM_SYNBUFF,			/*ͬļ INVOLID*/
			DUCP_CMD_FM_COLOSE,				/*رļ INVOLID*/
			DUCP_CMD_FM_DEL,				/*ɾļ INVOLID*/
			DUCP_CMD_FM_COPY,				/*ļ INVOLID*/
			DUCP_CMD_FM_FDISK,				/*ʽ INVOLID*/
			DUCP_CMD_FM_WLIC,				/*дȨļ*/
			DUCP_CMD_FM_RLIC,				/*Ȩļ*/
			DUCP_CMD_FM_CULIC,				/*УûȨļ*/

			/*-------------------TTSӿ----------------------------*/
			DUCP_CMD_TTS_PLAY = DUCP_CMD_TTS_BASE,/*OK*/
			DUCP_CMD_TTS_STOP,				/*ֹͣOK*/


			/*-------------------2Dͼνӿ-----------------------------*/
			DUCP_CMD_2D_DRAW_POINT = DUCP_CMD_2D_BASE,/* OK*/
			DUCP_CMD_2D_DRAW_LINE,			/* OK*/
			DUCP_CMD_2D_DRAW_RECT,			/* OK*/
			DUCP_CMD_2D_FILL_RECT,			/* OK*/
			DUCP_CMD_2D_DRAW_CICLE,			/*Բ OK*/
			DUCP_CMD_2D_FILL_CICLE,			/*Բ OK*/
			DUCP_CMD_2D_DRAW_BITMAP,		/*λͼ*/
			DUCP_CMD_2D_DIS_TEXT,			/*ʾı OK*/
			DUCP_CMD_2D_SET_TCOLOR,	 		/*ıɫ OK*/
			DUCP_CMD_2D_SET_BCOLOR,			/*ñɫ OK*/
			DUCP_CMD_2D_SET_FONT,			/* OK*/
			DUCP_CMD_2D_DRAW_SYSICON,		/*ϵͳԴͼOK*/
			
			/*----------------------ڹ---------------------------*/
			DUCP_CMD_WIN_SHOW = DUCP_CMD_WM_BASE,/*ʾ OK*/
			DUCP_CMD_WIN_HIDLE,				/*ش OK*/
			DUCP_CMD_WIN_DEL,				/*ɾ OK*/
			DUCP_CMD_WIN_AUTO_SYN,			/*Զͬʾ OK*/
			
			/*----------------------ıؼ---------------------------*/
			DUCP_CMD_TWIN_CREATE = DUCP_CMD_TWIN_BASE,/*ı OK*/
			DUCP_CMD_TWIN_DEL,				/*ɾı OK*/
			DUCP_CMD_TWIN_DIS_TEXT,			/*ʾʱı OK*/
			DUCP_CMD_TWIN_SET_FONT,	 		/* OK*/
			DUCP_CMD_TWIN_SET_TCOLOR,		/*ıɫ OK*/
			DUCP_CMD_TWIN_SET_BCOLOR,		/*ñɫ OK*/
			DUCP_CMD_TWIN_STOP_DIS,			/*ֹͣʾ OK*/
			DUCP_CMD_TWIN_DOWN_TFILE,		/*ıļ OK*/
			DUCP_CMD_TWIN_DIS_TFILE,		/*ʾıļ OK*/
			DUCP_CMD_TWIN_OPEN_TFILE,		/*ıļ OK*/
			DUCP_CMD_TWIN_CLOSE_TFILE,		/*رıļ OK*/
			DUCP_CMD_TWIN_DEL_TFILE,		/*ɾıļ OK*/
			DUCP_CMD_TWIN_SYN_DIS,			/*ͬʾıؼ*/
			DUCP_CMD_TWIN_SYN_DISEX,		/*ʾ,ͬʱ*/

			/*----------------------ͼƬؼ---------------------------*/
			DUCP_CMD_PIC_CREATE = DUCP_CMD_PIC_BASE,/*ͼƬ OK*/
			DUCP_CMD_PIC_DEL,
			DUCP_CMD_PIC_ADD,
			DUCP_CMD_PIC_CLR,

} DUCP_CMD_E;


typedef struct {
	char			DevName[8];/*豸*/
	char			SVR[8];		/*汾X.YZ*/
	uint32_t		XSize;		/*Xߴ*/
	uint32_t		YSize;		/*Yߴ*/
	uint32_t		LstUpTime;	/*ʱ*/
	uint8_t			SN[12];		/*к*/
}DEVICE_FRAMWARE_T;

/*IOűʶ*/
typedef enum {
	IO_PIN_1 = 0,
	IO_PIN_2,
	IO_PIN_3,
	IO_PIN_4,
	IO_PIN_ALL = 0XF0, /*IOڽиֵ*/
	IO_PIN_OR,/*IOڽ  */
	IO_PIN_AND,/*IOڽ  */
	IO_PIN_NOT/*IOڽ  */
} IO_PIN_ID_E;

/*IO ö*/
typedef enum {
	IO_FUN_IN = 0, 	/**/
	IO_FUN_PP,		/**/
	IO_FUN_OD,		/*©*/
} IO_PIN_FUN_E;


/*ϵͳ*/
typedef struct {
	uint32_t 	Baud;	/* 115200*/
	uint8_t  	_485Addr;/*485ַ*/
	uint8_t  	_485CM;/*485ģʽ 0:˫ 1:빤*/
	uint8_t  	IP[4];/*IPַ*/
	uint32_t  	Port;/*˿ں*/
	uint8_t	 	GW[4];/*صַ*/
	uint8_t	 	Mask[4];/**/
	uint16_t 	Fre;/*ɨƵ 30Hz ~ 960Hz*/
	uint8_t  	LightLevel;/*ȼ 10~100 Ӧ10% ~ 100%*/
	uint8_t  	VoiceLevel;/* 10~100 Ӧ10% ~ 100%*/
	uint8_t	 	OEP;/*OEԣ0: 1:*/
	uint8_t  	DP;/*ݼԣ0: 1:*/
	uint8_t  	LEDey;/*LEźʱ0:ر 1:*/
	uint8_t  	LEDDrv;/*LED 0:08˫ɫ16֮һɨ 1:12˫ɫ4֮һɨ 2:12˫ɫ8֮һɨ*/
	uint16_t 	XSize;/*ʾȳߴ */
	uint16_t 	YSize;/*ʾ߶ȳߴ */
	uint8_t	 	XYMir;/*XYʹ 0:ԭϽ 1:ԭ½*/
	uint8_t		TTSAEn;/*0:1:Բ(ҪⲿTTSģ)*/
} SysSettings_t;

#endif

