/*
****************************************************************************************************
*                                                DUCP
*                      				Displayer universal control protocal
*                                      	   Master Head File
*
*                          			(c) Copyright 2016-2017, KF 
*                                        All Rights Reserved
*
* File : DUCP.h
* By   : Lyon 
* Date : 2016-1-1
* Email: yangzhonglai@163.com
****************************************************************************************************
*/
#ifndef _DUCP_H_
#define _DUCP_H_

#define DUCP_PATH_LEN_MAX		(125)


#define DUCP_FM_READ			(0X01)
#define DUCP_FM_WRITE			(0X02)
#define DUCP_FM_OPEN_ALWAYS		(0X10)
#define DUCP_FM_FLLOW_PATH		(0X80)


#define SEND_MSG_OVERTIME_DEF		(100)
#define READ_MSG_OVERTIME_DEF		(100)


#define DUCP_TTS_PLAY_OPT_A			(0x00)	/*ӵеǲʼ*/
#define DUCP_TTS_PLAY_OPT_AS		(0x01)	/*ӵвҿʼ*/
#define DUCP_TTS_PLAY_OPT_CAS		(0x02)	/*УУȻʼ*/

/**/
#define DUCP_ERR_NONE				(0x00) /*޴*/
typedef uint8_t DUCP_ERR_T;

/*-------------------------UDCPָ----------------------------*/
#define DUCP_CMD_SYS_BASE		(0)
#define DUCP_CMD_FM_BASE		(0X20)
#define DUCP_CMD_TTS_BASE		(0X30)
#define DUCP_CMD_2D_BASE		(0X38)
#define DUCP_CMD_WM_BASE		(0X50)
#define DUCP_CMD_TWIN_BASE		(0X60)
#define DUCP_CMD_PIC_BASE		(0X80)

typedef enum {
			/*--------------------ϵͳ------------------------------*/
			DUCP_CMD_SYS_CONNECT = DUCP_CMD_SYS_BASE, /*¼UDCP OK*/		
			DUCP_CMD_SYS_SYN_PN,			/*ͬ OK*/		
			DUCP_CMD_SYS_SET_PASSWAORD,		/*޸ĵ¼ NOTEST*/
			DUCP_CMD_SYS_GET_PASSWAORD,		/*ȡ¼ NOTEST*/
			DUCP_CMD_SYS_GET_FIRMWARE,		/*ȡ̼ϢOK*/
			DUCP_CMD_SYS_UPTIME,			/*ʱOK*/
			DUCP_CMD_SYS_RESET,				/*ϵͳ OK*/

			DUCP_CMD_SYS_SET_ADDR,			/*485ַ OK*/
			DUCP_CMD_SYS_SET_IP,			/*IPַ OK*/
			DUCP_CMD_SYS_SET_PORT,			/*ö˿ OK*/
			DUCP_CMD_SYS_SET_BAUD,			/*òOK*/
			DUCP_CMD_SYS_SET_SCAN_FRE,		/*ɨƵOK*/
			DUCP_CMD_SYS_SET_LIGHT,	 		/*OK*/
			DUCP_CMD_SYS_SET_VOL,		 	/*OK*/
			
			DUCP_CMD_SYS_CFG_IO,			/*IOڹOK*/
			DUCP_CMD_SYS_SET_IO,			/*IO״̬OK*/
			DUCP_CMD_SYS_READ_IO,			/*ȡIO״̬OK*/

			DUCP_CMD_SYS_SET_DRV,			/*LED*/
			DUCP_CMD_SYS_SET_OEP,			/*OE*/
			DUCP_CMD_SYS_SET_DP,			/*ݼ*/
			DUCP_CMD_SYS_SET_LE,			/*LEźʱ*/
			DUCP_CMD_SYS_SET_GW_AND_MASK,	/*غ*/
			DUCP_CMD_SYS_SET_SAF_MODE,		/*밲ȫģʽ*/
			DUCP_CMD_SYS_CLIC,				/*Passport*/
			DUCP_CMD_SYS_SET_DIS_SIZE,		/*ʾߴ*/
			DUCP_CMD_SYS_SET_XYMIR,			/*ʾ*/
			
			/*--------------------ļ------------------------------*/
			DUCP_CMD_FM_MOUNT = DUCP_CMD_FM_BASE,/*Ŀ¼ INVOLID*/
			DUCP_CMD_FM_OPEN,				/*򿪻򴴽ļ INVOLID*/
			DUCP_CMD_FM_SEEK,				/*ļдλ INVOLID*/
			DUCP_CMD_FM_WRITE,				/*дļ INVOLID*/
			DUCP_CMD_FM_READ,				/*ļ INVOLID*/
			DUCP_CMD_FM_SYNBUFF,			/*ͬļ INVOLID*/
			DUCP_CMD_FM_COLOSE,				/*رļ INVOLID*/
			DUCP_CMD_FM_DEL,				/*ɾļ INVOLID*/
			DUCP_CMD_FM_COPY,				/*ļ INVOLID*/
			DUCP_CMD_FM_FDISK,				/*ʽ INVOLID*/

			/*-------------------TTSӿ----------------------------*/
			DUCP_CMD_TTS_PLAY = DUCP_CMD_TTS_BASE,/*OK*/
			DUCP_CMD_TTS_STOP,				/*ֹͣOK*/


			/*-------------------2Dͼνӿ-----------------------------*/
			DUCP_CMD_2D_DRAW_POINT = DUCP_CMD_2D_BASE,/* OK*/
			DUCP_CMD_2D_DRAW_LINE,			/* OK*/
			DUCP_CMD_2D_DRAW_RECT,			/* OK*/
			DUCP_CMD_2D_FILL_RECT,			/* OK*/
			DUCP_CMD_2D_DRAW_CICLE,			/*Բ OK*/
			DUCP_CMD_2D_FILL_CICLE,			/*Բ OK*/
			DUCP_CMD_2D_DRAW_BITMAP,		/*λͼ*/
			DUCP_CMD_2D_DIS_TEXT,			/*ʾı OK*/
			DUCP_CMD_2D_SET_TCOLOR,	 		/*ıɫ OK*/
			DUCP_CMD_2D_SET_BCOLOR,			/*ñɫ OK*/
			DUCP_CMD_2D_SET_FONT,			/* OK*/
			DUCP_CMD_2D_DRAW_SYSICON,		/*ϵͳԴͼOK*/
			
			/*----------------------ڹ---------------------------*/
			DUCP_CMD_WIN_SHOW = DUCP_CMD_WM_BASE,/*ʾ OK*/
			DUCP_CMD_WIN_HIDLE,				/*ش OK*/
			DUCP_CMD_WIN_DEL,				/*ɾ OK*/
			DUCP_CMD_WIN_AUTO_SYN,			/*Զͬʾ OK*/
			
			/*----------------------ıؼ---------------------------*/
			DUCP_CMD_TWIN_CREATE = DUCP_CMD_TWIN_BASE,/*ı OK*/
			DUCP_CMD_TWIN_DEL,				/*ɾı OK*/
			DUCP_CMD_TWIN_DIS_TEXT,			/*ʾʱı OK*/
			DUCP_CMD_TWIN_SET_FONT,	 		/* OK*/
			DUCP_CMD_TWIN_SET_TCOLOR,		/*ıɫ OK*/
			DUCP_CMD_TWIN_SET_BCOLOR,		/*ñɫ OK*/
			DUCP_CMD_TWIN_STOP_DIS,			/*ֹͣʾ OK*/
			DUCP_CMD_TWIN_DOWN_TFILE,		/*ıļ OK*/
			DUCP_CMD_TWIN_DIS_TFILE,		/*ʾıļ OK*/
			DUCP_CMD_TWIN_OPEN_TFILE,		/*ıļ OK*/
			DUCP_CMD_TWIN_CLOSE_TFILE,		/*رıļ OK*/
			DUCP_CMD_TWIN_DEL_TFILE,		/*ɾıļ OK*/
			DUCP_CMD_TWIN_SYN_DIS,			/*ͬʾıؼ*/
			DUCP_CMD_TWIN_SYN_DISEX,		/*ʾ,ͬʱ*/

			/*----------------------ͼƬؼ---------------------------*/
			DUCP_CMD_PIC_CREATE = DUCP_CMD_PIC_BASE,/*ͼƬ OK*/
			DUCP_CMD_PIC_DEL,
			DUCP_CMD_PIC_ADD,
			DUCP_CMD_PIC_CLR,

} DUCP_CMD_E;


typedef struct {
	char			DevName[8];/*豸*/
	char			SVR[8];		/*汾X.YZ*/
	uint32_t		XSize;		/*Xߴ*/
	uint32_t		YSize;		/*Yߴ*/
	uint32_t		LstUpTime;	/*ʱ*/
}DEVICE_FRAMWARE_T;

/*IOűʶ*/
typedef enum {
	IO_PIN_1 = 0,
	IO_PIN_2,
	IO_PIN_3,
	IO_PIN_4,
	IO_PIN_ALL = 0XF0, /*IOڽиֵ*/
	IO_PIN_OR,/*IOڽ  */
	IO_PIN_AND,/*IOڽ  */
	IO_PIN_NOT/*IOڽ  */
} IO_PIN_ID_E;

/*IO ö*/
typedef enum {
	IO_FUN_IN = 0, 	/**/
	IO_FUN_PP,		/**/
	IO_FUN_OD,		/*©*/
} IO_PIN_FUN_E;


#endif

